# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_identity_lib.api_client import ApiClient


class AuthenticationControllerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_access_token_pkce_flow(self, authorization, **kwargs):  # noqa: E501
        """Exchanges one of the following grants: authorization_code, refresh_token, client_credentials or client_delegate for access token.  # noqa: E501

        This end-point exchanges one of the following grants: authorization_code, refresh_token, client_credentials or client_delegate for an access token. 1. Include the parameters using application/x-www-form-urlencoded format in the HTTP request body. 2. Include Basic Base64_Encode(client_id:client_secret) value in the HTTP authorization header. Organization ID parameter notes: when organization id is missing from the request the default organization will be used. 3. Upon password grant type, user default organization will be set if available. 4. Upon client_credentials grant type, the organization who own the client will be set if available. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_access_token_pkce_flow(authorization, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization: Basic auth client credentials [Basic Base64_Encode(client_id:client_secret)].<br><strong>Example:</strong> <i>authorization: Basic Y2xpZW50X2lkOmNsaWVudF9zZWNyZXQ=</i><br>Decoding this string will literally return client_id:client_secret.<br><br>Note: when using <strong>Public OAuth clients</strong>, Authorization is required using the format 'Basic Base64_Encode(client_id:)' with empty client_secret.  (required)
        :param str grant_type:
        :param str code:
        :param str redirect_uri:
        :param str refresh_token:
        :param str scope:
        :param str org_id:
        :param str subject_token:
        :param str subject_token_type:
        :param str code_verifier:
        :param str identity_session:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_access_token_pkce_flow_with_http_info(authorization, **kwargs)  # noqa: E501
        else:
            (data) = self.get_access_token_pkce_flow_with_http_info(authorization, **kwargs)  # noqa: E501
            return data

    def get_access_token_pkce_flow_with_http_info(self, authorization, **kwargs):  # noqa: E501
        """Exchanges one of the following grants: authorization_code, refresh_token, client_credentials or client_delegate for access token.  # noqa: E501

        This end-point exchanges one of the following grants: authorization_code, refresh_token, client_credentials or client_delegate for an access token. 1. Include the parameters using application/x-www-form-urlencoded format in the HTTP request body. 2. Include Basic Base64_Encode(client_id:client_secret) value in the HTTP authorization header. Organization ID parameter notes: when organization id is missing from the request the default organization will be used. 3. Upon password grant type, user default organization will be set if available. 4. Upon client_credentials grant type, the organization who own the client will be set if available. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_access_token_pkce_flow_with_http_info(authorization, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization: Basic auth client credentials [Basic Base64_Encode(client_id:client_secret)].<br><strong>Example:</strong> <i>authorization: Basic Y2xpZW50X2lkOmNsaWVudF9zZWNyZXQ=</i><br>Decoding this string will literally return client_id:client_secret.<br><br>Note: when using <strong>Public OAuth clients</strong>, Authorization is required using the format 'Basic Base64_Encode(client_id:)' with empty client_secret.  (required)
        :param str grant_type:
        :param str code:
        :param str redirect_uri:
        :param str refresh_token:
        :param str scope:
        :param str org_id:
        :param str subject_token:
        :param str subject_token_type:
        :param str code_verifier:
        :param str identity_session:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization', 'grant_type', 'code', 'redirect_uri', 'refresh_token', 'scope', 'org_id', 'subject_token', 'subject_token_type', 'code_verifier', 'identity_session']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_access_token_pkce_flow" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'authorization' is set
        if ('authorization' not in params or
                params['authorization'] is None):
            raise ValueError("Missing the required parameter `authorization` when calling `get_access_token_pkce_flow`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'grant_type' in params:
            form_params.append(('grant_type', params['grant_type']))  # noqa: E501
        if 'code' in params:
            form_params.append(('code', params['code']))  # noqa: E501
        if 'redirect_uri' in params:
            form_params.append(('redirect_uri', params['redirect_uri']))  # noqa: E501
        if 'refresh_token' in params:
            form_params.append(('refresh_token', params['refresh_token']))  # noqa: E501
        if 'scope' in params:
            form_params.append(('scope', params['scope']))  # noqa: E501
        if 'org_id' in params:
            form_params.append(('org_id', params['org_id']))  # noqa: E501
        if 'subject_token' in params:
            form_params.append(('subject_token', params['subject_token']))  # noqa: E501
        if 'subject_token_type' in params:
            form_params.append(('subject_token_type', params['subject_token_type']))  # noqa: E501
        if 'code_verifier' in params:
            form_params.append(('code_verifier', params['code_verifier']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/auth/token', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_access_token_with_authorization_request(self, **kwargs):  # noqa: E501
        """Get an access token.  # noqa: E501

        Exchange authorization code, refresh token or client_credentials to user access token. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_access_token_with_authorization_request(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AuthAuthorizeBody body:
        :param str authorization:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_access_token_with_authorization_request_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_access_token_with_authorization_request_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_access_token_with_authorization_request_with_http_info(self, **kwargs):  # noqa: E501
        """Get an access token.  # noqa: E501

        Exchange authorization code, refresh token or client_credentials to user access token. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_access_token_with_authorization_request_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AuthAuthorizeBody body:
        :param str authorization:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_access_token_with_authorization_request" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/auth/authorize', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_access_token_with_refresh_token(self, **kwargs):  # noqa: E501
        """Exchange organization scoped API-token for user access token.  # noqa: E501

        **To obtain the access token please follow the steps described in the official product documentation. Using the token generated by the Identity Service API alone will not work due to a missing internal state.**<br>DEPRECATED: Passing the refresh_token param name, need to use api_token. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_access_token_with_refresh_token(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApitokensAuthorizeBody body:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_access_token_with_refresh_token_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_access_token_with_refresh_token_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_access_token_with_refresh_token_with_http_info(self, **kwargs):  # noqa: E501
        """Exchange organization scoped API-token for user access token.  # noqa: E501

        **To obtain the access token please follow the steps described in the official product documentation. Using the token generated by the Identity Service API alone will not work due to a missing internal state.**<br>DEPRECATED: Passing the refresh_token param name, need to use api_token. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_access_token_with_refresh_token_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApitokensAuthorizeBody body:
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_access_token_with_refresh_token" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/auth/api-tokens/authorize', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_keys(self, **kwargs):  # noqa: E501
        """Defines the public keys used to verify the authenticity of the JWT token.  # noqa: E501

        Defines the public keys used to verify the authenticity of the JWT token. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_keys(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20035
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_keys_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_keys_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_keys_with_http_info(self, **kwargs):  # noqa: E501
        """Defines the public keys used to verify the authenticity of the JWT token.  # noqa: E501

        Defines the public keys used to verify the authenticity of the JWT token. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_keys_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20035
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_keys" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/auth/keys', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20035',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_public_key(self, **kwargs):  # noqa: E501
        """Returns the public key.  # noqa: E501

        Returns the public key to be used for verifying the idp generated tokens signature. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_public_key(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwks:
        :param str pem:
        :return: InlineResponse20035
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_public_key_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_public_key_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_public_key_with_http_info(self, **kwargs):  # noqa: E501
        """Returns the public key.  # noqa: E501

        Returns the public key to be used for verifying the idp generated tokens signature. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_public_key_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwks:
        :param str pem:
        :return: InlineResponse20035
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['jwks', 'pem']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_public_key" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'jwks' in params:
            query_params.append(('jwks', params['jwks']))  # noqa: E501
        if 'pem' in params:
            query_params.append(('pem', params['pem']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/auth/token-public-key', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20035',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def logout(self, body, **kwargs):  # noqa: E501
        """Performs logout.  # noqa: E501

        Performs a logout by invalidating the supplied token (if supplied) and returning an URL to navigate to. The token to invalidate is first looked up in the request body. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.logout(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AuthLogoutBody body: (required)
        :param str id_token:
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.logout_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.logout_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def logout_with_http_info(self, body, **kwargs):  # noqa: E501
        """Performs logout.  # noqa: E501

        Performs a logout by invalidating the supplied token (if supplied) and returning an URL to navigate to. The token to invalidate is first looked up in the request body. ### Access Policy | Role | Access | | ----- | ----- | | Anonymous | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.logout_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AuthLogoutBody body: (required)
        :param str id_token:
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'id_token']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method logout" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `logout`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'id_token' in params:
            header_params['idToken'] = params['id_token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/auth/logout', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2004',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
